#pragma once
/*
 * Copyright (c) 1993 Free Software Foundation, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <memory>
#include <iostream>
#include <string>
#include <cstdio>

#include "global.h"
#include "cell.h"
#include "sheet.h"

/* extern char * fmt_to_str (int fmt);	*/
const char *cell_format_string(CELL *cp);
extern int str_to_fmt (char *ptr);
const char * jst_to_str (int jst);
extern int chr_to_jst (int chr);


// https://stackoverflow.com/questions/2342162/stdstring-formatting-like-sprintf/3742999#3742999
template<typename ... Args>
std::string string_format( const std::string& format, Args ... args )
{
    size_t size = snprintf( nullptr, 0, format.c_str(), args ... ) + 1; // Extra space for '\0'
    std::unique_ptr<char[]> buf( new char[ size ] ); 
    snprintf( buf.get(), size, format.c_str(), args ... );
    return std::string( buf.get(), buf.get() + size - 1 ); // We don't want the '\0' inside
}

std::string string_coord(coord_t coord);
std::string string_coord(CELLREF r, CELLREF c);
